/*  BotikBalance - User's account balance informer for Botik Network 
 *                 for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2005 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Sorry for the long lines in the sources, I have wide screen... ;-)
 */

#ifndef __NOTIFYICON_H__
#define __NOTIFYICON_H__

#define WM_USER_NOTIFYICON	WM_USER+1

#include <vector>

class CNotifyIcon
{
public:
	CNotifyIcon(void);
	~CNotifyIcon(void);

	BOOL Create(HINSTANCE hInst_, HWND hWnd_, UINT uID_);
	BOOL Destroy();
	BOOL AddIcon(UINT uIcon_, LPCTSTR szFormat_, ...);
	BOOL ShowIcon(UINT uPos_);
	BOOL HideIcon();
	BOOL SetRotatingRange(UINT uFrom_, UINT uTo_);
	BOOL ChangeText(UINT uPos_, LPCTSTR szFormat_, ...);

	LRESULT OnTimer(HWND hWnd_, WPARAM wParam_, LPARAM lParam_);
	LRESULT OnTaskbarCreated(HWND hWnd_, WPARAM wParam_, LPARAM lParam_);

private:
	typedef std::vector<string> UI2STR;
	typedef std::vector<HICON> UI2HI;
	typedef UI2STR::iterator UI2STRIT;
	typedef UI2HI::iterator UI2HIIT;

private:
	HINSTANCE	m_hInst;
	HWND		m_hWnd;
	UINT		m_uID;
	INT			m_nShowPos;

	INT			m_nFrom;
	INT			m_nTo;

	UI2STR		m_mapUint2Str;
	UI2HI		m_mapUint2Hico;
};

#endif // __NOTIFYICON_H__